﻿Public Class Taxi
    Inherits Vehicle
    'フィールド==========
    Private MaxSpeed As Integer     '最大スピード

    'プロパティ==========
    Public Property Unchin As Integer       '売上金額
    Public Property Distance As Double      '走行距離
    Public Property Aboard As Boolean       '乗車状態

    'コンストラクタ==========
    Public Sub New(gas As Double, maxspeed As Integer)
        MyBase.New(gas)
        'ガソリン量が容量を超えている場合は、最大容量をガソリン残量にセット
        If Me.Gas > 70 Then
            Me.Gas = 70
        End If
        Me.MaxSpeed = maxspeed
    End Sub

    'メソッド==========
    Public Overrides Sub SpeedUp(sp As Integer)
        '消費するガソリンがない場合は加速しない
        If Not ((Me.Gas - sp / 20.0) <= 0) Then
            '加速
            Me.Speed += sp
            Me.Gas -= sp / 20.0
        End If

        'スピードが最大スピードを超えていたら、最大スピードにセット
        If Me.Speed > Me.MaxSpeed Then
            Me.Speed = Me.MaxSpeed
        End If
    End Sub

    Public Function RideToTaxi(price As Integer, distance As Double) As String
        '乗車中かどうか
        If Me.Aboard Then
            Return "乗車中です。"
        End If

        '走行中かどうか
        If Me.Speed <> 0 Then
            Return "停車してください。"
        End If

        '運賃、距離を加算
        Me.Unchin += price
        Me.Distance += distance
        Me.Aboard = True
        Return Nothing
    End Function

    Public Function GetOffTaxi() As String
        '乗車中かどうか
        If Not Me.Aboard Then
            Return "乗車していません。"
        End If

        '走行中かどうか
        If Me.Speed <> 0 Then
            Return "停車してください。"
        End If

        '乗車の状態を変更
        Me.Aboard = False
        Return Nothing
    End Function
End Class
